package EDU.auburn.VGJ.frontend;

import EDU.auburn.VGJ.graph.*;
import EDU.auburn.VGJ.gui.*;
import webflow.backend.*;
import webflow.frontend.*;
import webflow.frontend.ModuleControls.CPanel;
import java.util.*;
import java.net.*;
import java.io.*;

public class compgraph {

  private NodeList List;
  private Node  node;
  private int   imax;
  private int    i,j;
  private int idx,id;
  private int   nedg;
  private String moduleName;
  String smURL;
  GraphWindow GW;
  int ntotal;
  String hostName;
  String ClientID;
  int portNumber;
  CPanel am;

  public compgraph(GraphWindow GW_, NodeList NodeList_, String SM_URL) {
    List = NodeList_;
    smURL = SM_URL;
    GW = GW_;
  }


  public void tomnodelist () {

    imax = List.count();
    hostName = GW.hostName;
    ClientID = GW.ClientID;
    portNumber = GW.portNumber;   
    am = GW.tomPanel.Executor;
    ntotal=0;

    if(imax>0) {
      node = List.firstNode();
      moduleName = node.getLabel();
      id=node.getId();
      System.err.println("0 node is :"+moduleName+" id = "+id);

      for(i=1;i<imax;i++) {
         node = List.nextNode(node);
         id=node.getId();
         moduleName = node.getLabel();
         System.err.println(i+" node is :"+moduleName+" id = "+id);
      }

      System.err.println("... now Edges ...");

      node = List.firstNode(); 
      nedg = node.numberOfChildren();
      if(nedg>0) { 
        idx = node.firstChild();
        System.err.println("Edge 0->"+idx);
      }
      if(nedg>1) {
	for(j=1;j<nedg;j++) {
         idx = node.nextChild();
         System.err.println("Edge 0->"+idx);
	}
      }      

      for(i=1;i<imax;i++) {
         node = List.nextNode(node);
         nedg = node.numberOfChildren();
         if(nedg>0) {
            idx = node.firstChild();
            System.err.println("Edge "+i+"->"+idx);
         }
         if(nedg>1) {
	   for(j=1;j<nedg;j++) {
           idx = node.nextChild();
           System.err.println("Edge "+i+"->"+idx);
	   }
         }      
      }
    }
  }

  // adopted from WebEeditor

  /**
  * <ol>
  *  <li> Open an Url connection to the SessionManager Object
  *  <li> Tell her your ClientId, new_module request and the name of the module.
  *  <li> Wait its response.
  *  <li> If the first word of first line is OK, this means that 
  *       she got the message and everything is ok. Then read the
  *       port number from the second line to read the result of the
  *       operation.
  * </ol>
  *
  */

  SMreply 
  requestFromServer(String request)
  {

    SMreply reply = null;
    int current_portNumber = -1;

    if(request==null) return null;

    try
    {
      System.err.println("start requestFromServer");
      //Added by Erol for chache problem
      Date dt = new Date ();
      String tmp = Long.toString(dt.getTime());
      request = request+"&time="+tmp;
      System.err.println("request: "+request);
           
      URL myReq = new URL(request);
      
      try
      {
        DataInputStream dis = new DataInputStream( myReq.openStream() );
        
        String status = dis.readLine();
        StringTokenizer STstatus = new StringTokenizer(status);
        
   System.err.println(" I read status :"+status);

        if( STstatus.countTokens() > 0 &&  
            STstatus.nextElement().equals("OK")  )
        {
          String SportNumber = dis.readLine();
   System.err.println(" I read SportNumber:"+SportNumber+"|");
          
          current_portNumber = Integer.parseInt(SportNumber); 

        } else return reply;

      } catch ( IOException e)
        {
           System.err.println("IOException is raised!");
           e.printStackTrace();
           return reply;
        }

    } catch ( MalformedURLException mue)
      {
        System.err.println(" MalformedURLException is raised!");
        mue.printStackTrace();
        return reply;
      } 
 
    /** If port number is invalid exit */
    if( current_portNumber < 1 ) return reply;

    Socket Csocket = null;
    DataInputStream  Cdin  = null;
    DataOutputStream Cdout = null;

    try
    {
      Csocket = new Socket(hostName, current_portNumber );

      Cdin = new DataInputStream( Csocket.getInputStream() );

      Cdout = new DataOutputStream( Csocket.getOutputStream() );

    } catch( UnknownHostException e)
      {
         System.err.println("UnknownHostException" + e +" raised!");
         e.printStackTrace(); 
         return reply;
      }
      catch( IOException e)
      {
         System.err.println("IOException (2)" + e + " raised!");
         e.printStackTrace(); 
         return reply;
      }
      
   
    reply = new SMreply();

    try
    {
      reply.fromStream(Cdin);

      if(reply.getStatus() == SMreply.ERROR) 
       	System.err.println( reply.getDescription());

    } catch( NullPointerException e)
      {
         System.err.println("NullPointerException vo requestInit" + e);
         e.printStackTrace();
         return null;
      }

    return reply;

  }// end of requestFromServer()

  /**
  * Initialize the module
  */
  public SMreply 
  requestInit(ModuleTreeItem m)
  { 
     String myreq = new String(smURL+"?cmd=new_module&ClientID="+
                               ClientID+"&name="+m.getClassName());

     //System.out.println("req(InitModule):"+ myreq);


     ntotal++;
     if(ntotal>10) {System.out.println("too many modules!!!!!!!!!!!!!!!");}
     int lastdot = m.getClassName().lastIndexOf(".")+1;
     String mname = m.getClassName().substring(lastdot);
     System.out.println("---> HASH of "+mname);
     Integer r1 = (Integer)am.lp.ModuleNames.get(mname);
     System.out.println("R1: "+r1+" of "+ntotal);
     
     if(r1 != null) {
         int r2 = r1.intValue();
         am.addNewModule(ntotal,r2,mname);
     }
     else {
        am.addNewModule(ntotal,0,mname);
     }

     System.out.println("End of requestInit ");

     return requestFromServer(myreq); 

  }// end of requestInit()


  /**
  */
  public SMreply
  connect(ID from, ID to, ID fromModule, ID toModule )
  {
    String req = new String(smURL+"?cmd=connect&ClientID="+ClientID);
    req += "&fromStr="+from.getString();
    req += "&fromVal="+from.getInt();
    req += "&toStr="+to.getString();
    req += "&toVal="+to.getInt();
    req += "&mIDfromStr="+fromModule.getString();
    req += "&mIDfromVal="+fromModule.getInt();
    req += "&mIDtoStr="+toModule.getString();
    req += "&mIDtoVal="+toModule.getInt();

    return requestFromServer( req );

  }// end of connect()

  /**
  * Runs all the modules in the current session
  */
  public SMreply
  runModules()
  {
     String req = new String(smURL+"?cmd=run_modules&ClientID="+ClientID);

     return requestFromServer(req);

  }// end of run()


}






